﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ArcGIS.Desktop.Framework;
using ArcGIS.Desktop.Framework.Contracts;
using ArcGIS.Desktop.Mapping;
using ArcGIS.Core.Data;
using ArcGIS.Desktop.Core;
using ArcGIS.Desktop.Core.Geoprocessing;
using ArcGIS.Desktop.Framework.Dialogs;

namespace AsyncCoarse
{
  internal class TestAsync : Button
  {
    protected override void OnClick()
    {
      CorseGrainedMethodsAsync();
    }

    /// <summary>
    /// you can start with a blank map
    /// </summary>
    private async Task CorseGrainedMethodsAsync()
    {
      try
      {
        //Execute a GP Tool
        // Add the await keyword
        await Geoprocessing.ExecuteToolAsync("SelectLayerByAttribute_management",
             new string[] { "TerritorialStats_3", "NEW_SELECTION",
               "name = 'Zürich'" });
        // Add the await keyword
        await MapView.Active.ZoomToSelectedAsync(new TimeSpan(0, 0, 10));
      }
      catch (Exception ex)
      {
        MessageBox.Show($@"Exception: {ex}");
      }
      MessageBox.Show("CorseGrainedMethods is done");
    }

  }
}
